
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Logging in Varnish &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Statistics" href="operation-statistics.html" />
    <link rel="prev" title="Reporting and statistics" href="report.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="operation-statistics.html" title="Statistics"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="report.html" title="Reporting and statistics"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="report.html" accesskey="U">Reporting and statistics</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Logging in Varnish</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="logging-in-varnish">
<span id="users-guide-logging"></span><h1>Logging in Varnish<a class="headerlink" href="#logging-in-varnish" title="Permalink to this headline">¶</a></h1>
<p>One of the really nice features in Varnish is the way logging
works. Instead of logging to a normal log file Varnish logs to a shared
memory segment, called the VSL - the Varnish Shared Log. When the end
of the segment is reached we start over, overwriting old data.</p>
<p>This is much, much faster than logging to a file and it doesn’t
require disk space. Besides it gives you much, much more information
when you need it.</p>
<p>The flip side is that if you forget to have a program actually write the
logs to disk they will be overwritten.</p>
<p><cite>varnishlog</cite> is one of the programs you can use to look at what Varnish
is logging. <cite>varnishlog</cite> gives you the raw logs, everything that is
written to the logs. There are other clients that can access the logs as well, we’ll show you
these later.</p>
<p>In the terminal window you started Varnish now type <code class="docutils literal notranslate"><span class="pre">varnishlog</span> <span class="pre">-g</span> <span class="pre">raw</span></code>
and press enter.</p>
<p>You’ll see lines like these scrolling slowly by.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="mi">0</span> <span class="n">CLI</span>            <span class="o">-</span> <span class="n">Rd</span> <span class="n">ping</span>
<span class="mi">0</span> <span class="n">CLI</span>            <span class="o">-</span> <span class="n">Wr</span> <span class="mi">200</span> <span class="mi">19</span> <span class="n">PONG</span> <span class="mi">1273698726</span> <span class="mf">1.0</span>
</pre></div>
</div>
<p>These is the Varnish master process checking up on the caching process
to see that everything is OK.</p>
<p>Now go to the browser and reload the page displaying your web app.</p>
<p>You’ll see lines like these.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="mi">11</span> <span class="n">SessOpen</span>       <span class="n">c</span> <span class="mf">127.0.0.1</span> <span class="mi">58912</span> <span class="p">:</span><span class="mi">8080</span> <span class="mf">0.0.0.0</span> <span class="mi">8080</span> <span class="mf">1273698726.933590</span> <span class="mi">14</span>
<span class="mi">11</span> <span class="n">ReqStart</span>       <span class="n">c</span> <span class="mf">127.0.0.1</span> <span class="mi">58912</span>
<span class="mi">11</span> <span class="n">ReqMethod</span>      <span class="n">c</span> <span class="n">GET</span>
<span class="mi">11</span> <span class="n">ReqURL</span>         <span class="n">c</span> <span class="o">/</span>
<span class="mi">11</span> <span class="n">ReqProtocol</span>    <span class="n">c</span> <span class="n">HTTP</span><span class="o">/</span><span class="mf">1.1</span>
<span class="mi">11</span> <span class="n">ReqHeader</span>      <span class="n">c</span> <span class="n">Host</span><span class="p">:</span> <span class="n">localhost</span><span class="p">:</span><span class="mi">8080</span>
<span class="mi">11</span> <span class="n">ReqHeader</span>      <span class="n">c</span> <span class="n">Connection</span><span class="p">:</span> <span class="n">keep</span><span class="o">-</span><span class="n">alive</span>
</pre></div>
</div>
<p>The first column is an arbitrary number, it identifies the
transaction. Lines with the same number are coming from the same
transaction. The second column is the <em>tag</em> of the log message. All
log entries are tagged with a tag indicating what sort of activity is
being logged.</p>
<p>The third column tell us whether this is is data coming from or going
to the client (‘c’), or the backend (‘b’). The forth column is the data
being logged.</p>
<p>Now, you can filter quite a bit with <cite>varnishlog</cite>. The basic options we think you
want to know are:</p>
<dl class="simple">
<dt>‘-b’</dt><dd><p>Only show log lines from traffic going between Varnish and the backend
servers. This will be useful when we want to optimize cache hit rates.</p>
</dd>
<dt>‘-c’</dt><dd><p>Same as ‘-b’ but for client side traffic.</p>
</dd>
<dt>‘-g request’</dt><dd><p>Group transactions by request.</p>
</dd>
<dt>‘-q query’</dt><dd><p>Only list transactions matching this query.</p>
</dd>
</dl>
<p>For more information on this topic please see <a class="reference internal" href="../reference/varnishlog.html#varnishlog-1"><span class="std std-ref">varnishlog</span></a>.</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="report.html"
                        title="previous chapter">Reporting and statistics</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="operation-statistics.html"
                        title="next chapter">Statistics</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/operation-logging.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="operation-statistics.html" title="Statistics"
             >next</a> |</li>
        <li class="right" >
          <a href="report.html" title="Reporting and statistics"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="report.html" >Reporting and statistics</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Logging in Varnish</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>